From: Greg KH <greg@kroah.com>
To: torvalds@transmeta.com
Cc: linux-usb-devel@lists.sourceforge.net
Subject: [PATCH 5 of 6] USB hcd bugfix

Hi,

Here's a patch against 2.5.3-pre5 that fixes a bug in the USB hcd code.
Now the correct status is returned for a async unlink of an urb.
This patch was done by David Brownell.

thanks,

greg k-h


diff -Nru a/drivers/usb/hcd.c b/drivers/usb/hcd.c
--- a/drivers/usb/hcd.c	Fri Jan 25 10:29:59 2002
+++ b/drivers/usb/hcd.c	Fri Jan 25 10:29:59 2002
@@ -1175,6 +1181,8 @@
 			dbg ("%s: wait for giveback urb %p",
 				hcd->bus_name, urb);
 		}
+	} else if ((urb->transfer_flags & USB_ASYNC_UNLINK) && retval == 0) {
+		return -EINPROGRESS;
 	}
 	goto bye;
 done:

